package com.sambath.kunkhmer.screen.event

import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import com.sambath.kunkhmer.R
import com.sambath.kunkhmer.app.App
import kotlinx.android.synthetic.main.fragment_event_admin.view.et_desc
import kotlinx.android.synthetic.main.fragment_event_admin.view.et_match_fighter_id
import kotlinx.android.synthetic.main.fragment_event_admin.view.et_title
import kotlinx.android.synthetic.main.fragment_event_admin.view.submitButton

class EventAdminFragment : Fragment() {
    private var _root: View? = null
    private val binding get() = _root!!
    private lateinit var eventViewModel: EventViewModel

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        _root = inflater.inflate(R.layout.fragment_event_admin, container, false)

        eventViewModel = EventViewModel(App.injectApiService(), App.injectPrefHelper())
        eventViewModel.state.observe(viewLifecycleOwner, androidx.lifecycle.Observer {
            render(it)
        })

        setDefaultData()
        binding.submitButton.setOnClickListener{
            eventViewModel.createEvent(
                binding.et_title.text.toString(),
                binding.et_desc.text.toString(),
                binding.et_match_fighter_id.text.toString()
            )
        }

        // Inflate the layout for this fragment
        return binding
    }

    private fun setDefaultData() {
        binding.et_match_fighter_id.setText("650ea3b6b66ab4183c1657c1")
        binding.et_title.setText("Prum Samnang VS Thoeun Theara")
        binding.et_desc.setText("Prum Samnang VS Thoeun Theara")
    }

    private fun render(state: EventViewModel.EventViewState) {
        if (state.isLoginSuccess) {
            Toast.makeText(context, "Create Success...", Toast.LENGTH_LONG).show()

            binding.et_title.setText("")
            binding.et_desc.setText("")
            binding.et_match_fighter_id.setText("")
        }
        // Other state handling...
    }
}