package com.sambath.kunkhmer.screen.lives

import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.RadioButton
import android.widget.Toast
import com.sambath.kunkhmer.R
import com.sambath.kunkhmer.app.App
import com.sambath.kunkhmer.remote.CreateLivesRequest
import com.sambath.kunkhmer.remote.CreateProductRequest
import kotlinx.android.synthetic.main.fragment_lives_admin.view.et_match_fighter_id
import kotlinx.android.synthetic.main.fragment_lives_admin.view.et_url
import kotlinx.android.synthetic.main.fragment_lives_admin.view.radio_group_status
import kotlinx.android.synthetic.main.fragment_lives_admin.view.submitButton

class LivesAdminFragment : Fragment() {
    private var _root: View? = null
    private val binding get() = _root!!
    private lateinit var livesViewModel: LivesViewModel

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        // Inflate the layout for this fragment
        _root = inflater.inflate(R.layout.fragment_lives_admin, container, false)
        livesViewModel = LivesViewModel(App.injectApiService(), App.injectPrefHelper())
        livesViewModel.state.observe(viewLifecycleOwner, androidx.lifecycle.Observer {
            render(it)
        })

        setDefault()

        binding.submitButton.setOnClickListener {
            val selectedId = binding.radio_group_status.checkedRadioButtonId
            var status = false
            if (selectedId != -1) { // -1 indicates no radio button is checked
                val selectedRadioButton: RadioButton = binding.findViewById(selectedId)
                val selectedValue: String = selectedRadioButton.text.toString()
                if (selectedValue == "True") {
                    status = true
                }
            }

            val createLivesRequest = CreateLivesRequest(
                binding.et_match_fighter_id.text.toString(), status, binding.et_url.text.toString()
            )

            livesViewModel.createLives(createLivesRequest.matchFighterId, createLivesRequest.status, createLivesRequest.url)
        }

        return binding
    }

    private fun setDefault() {
        binding.et_match_fighter_id.setText("650ea3b6b66ab4183c1657c1")
        binding.et_url.setText("https://youtu.be/xZtadif15WU")
    }


    private fun render(state: LivesViewModel.LivesViewState) {
        if (state.isLoginSuccess) {
            Toast.makeText(context, "Create Success...", Toast.LENGTH_LONG).show()

            binding.et_match_fighter_id.setText("")
            binding.et_url.setText("")
        }
        // Other state handling...
    }
}